var ip;
var port;

this.ip = document.location.hostname;
this.port = document.location.port;
this.protocol = document.location.protocol;

console.log("DNS: "+ ip);
console.log("Port: "+ port);
console.log("Protocol: "+ protocol);
if (port==""){
    if(protocol=="http:"){
        port = "80";
    }else{
        port = "443";
    }
}

// Testzwecke Lokal:
//ip = "192.168.1.56"
//port=80;
//protocol="http:";

var language;
var userset;

var counterCalendar;
var checkStart = true;
var datebool;
var calendarIndex;
var myCalendarEntries;
var users = true;

var startValue;
var endValue;

var currentLanguage;

var id = 0;
var xmlOptions = ["ID", "format", "output", "timeTable", "audio", "timeSettings", "generalSettings", "active", "streaming"];

//Initializes elements for general app functionality and contents
function InitJS(){
    myCalendarEntries = document.getElementsByClassName("calendarEntries");
    loadXMLDoc();

    document.getElementById("delStream").action = protocol +"//" + ip + ":" + port + "/local/GGVideoStreamer/input.cgi";
    document.getElementById("startStream").action = protocol +"//" + ip + ":" + port + "/local/GGVideoStreamer/manage.cgi";
    document.getElementById("stopStream").action = protocol +"//" + ip + ":" + port + "/local/GGVideoStreamer/manage.cgi";
    document.getElementById("editModal").action = protocol +"//" + ip + ":" + port + "/local/GGVideoStreamer/input.cgi";
    document.getElementById("addModal").action = protocol +"//" + ip + ":" + port + "/local/GGVideoStreamer/input.cgi";
    document.getElementById("languageForm").action = protocol +"//" + ip + ":" + port + "/local/GGVideoStreamer/input.cgi";
    document.getElementById("addResolution").action = protocol +"//" + ip + ":" + port + "/axis-cgi/param.cgi";
    document.getElementById("getAllUsers").action = protocol +"//" + ip + ":" + port + "/axis-cgi/pwdgrp.cgi";
    document.getElementById("userForm").action=protocol +"//"+ip + ":" + port+"/axis-cgi/param.cgi";
    document.getElementById("sendAnom").action=protocol +"//"+ip + ":" + port+"/local/GGVideoStreamer/user.cgi";
    document.getElementById("sendUser").action=protocol +"//"+ip + ":" + port+"/local/GGVideoStreamer/user.cgi";

    document.getElementById("addResolution").submit();

    document.getElementById('hidden-form-user').onload = function() {
        console.log("The hidden-form-user is loaded");
        checkUserAngaben();
      };
    document.getElementById('myhiddenform').onload = function() {
        console.log("The myhiddenform is loaded");
        getUsers();
      };
    document.getElementById('hidden-form-resolution').onload = function() {
        console.log("The hidden-form-resolution is loaded");
        getResolution();
      };


}

//Checks validity of app license
function loadXMLDoc() {
    var xmlhttp = new XMLHttpRequest();

    xmlhttp.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            tableCreator(this);
        }
    };
    xmlhttp.open("GET", protocol +"//" + this.ip + ":" + port + "/local/GGVideoStreamer/output.cgi?action=list", true);
    xmlhttp.onerror = function (e){
        //alert("Sie m&uuml;ssen die Lizenz einbinden oder die App einschalten!");
        document.getElementById("buttonLizenz").click();
    }


      xmlhttp.onload = function () {
        console.log('DONE: ', xmlhttp.status);
        if(xmlhttp.status==500){
            //alert("Sie muessen die Lizenz einbinden oder die App einschalten!");
            document.getElementById("buttonLizenz").click();
        }
      };
    console.log(xmlhttp.status);
    xmlhttp.send();
}

//Changes Timetable based on user choice
function changeTimeTable(node) {
    setDefaultWeekdays()
    switch (node.selectedIndex) {
        case 0: document.getElementById("wochentage").hidden = true; document.getElementById("calendarDiv").hidden = true; break;
        case 1: document.getElementById("wochentage").hidden = false; document.getElementById("calendarDiv").hidden = true; break;
        case 2: console.log("Kalender"); document.getElementById("wochentage").hidden = true; document.getElementById("calendarDiv").hidden = false; break;
    }
}

//changes app language based on user choice
function setLanguageArea(language) {
    switch(language){
        case "0": document.getElementById("lDeutsch").click();break;
        case "1": document.getElementById("lEnglisch").click();break
        case "2": document.getElementById("lFranzoesisch").click();break;
        case "3": document.getElementById("lJapanisch").click();break;
    }
}

//creates stream tables for new streams
function tableCreator(xml) {
    var i;

    var xmlDoc = xml.responseXML;
    var table = "<tr><th id='lPlattform'>Plattform<th id='lServerUrl'>Server Url</th><th id='lAktion'>Aktion</th></tr>";
    var x = xmlDoc.getElementsByTagName("stream");
    userset = xmlDoc.getElementsByTagName("usermode");
    language =xmlDoc.getElementsByTagName("language")[0].childNodes[0].nodeValue;
    setLanguageArea(language);
    
    for (i = 0; i < x.length; i++) {
        table += "<tr  onclick='setID(this)'  ><td data-toggle='modal' data-target='#ModalStreamSettings' hidden='true'>" +
            x[i].getElementsByTagName("ID")[0].childNodes[0].nodeValue +
            "</td><td data-toggle='modal' data-target='#ModalStreamSettings'>" +
            createHTMLFormat(x[i].getElementsByTagName("format")[0].childNodes[0].nodeValue) +
            "</td><td data-toggle='modal' data-target='#ModalStreamSettings'>";
        if(x[i].getElementsByTagName("output")[0].childNodes.length>0){
            table += x[i].getElementsByTagName("output")[0].childNodes[0].nodeValue;
        }

        table += "</td><td>" +
            createActionButtons(x[i]) +
            "</td></tr>";
    }
    table += '<tr><td hidden="true"></td><td></td><td></td><td ><button class="fa fa-plus-square" id="addEntry" data-toggle="modal" data-target="#ModalStreamSettings"   type="button"style="font-size:30px;color :rgba(0, 134, 204) ;background:transparent; border:none" ></button></td></tr>'
    document.getElementById("table").innerHTML = table;
    if(checkStart){
        document.getElementById("userForm").submit();
    }
};

//sets format symbole based on streamtype
function createHTMLFormat(node) {
    switch (node) {
        case "0": return "<label class='navbar-toggler' margin-left='10px'><i class='fa fa-video-camera' style='font-size:25px;color:black;' aria-hidden='true'></i></label>";
        case "1": return "<label class='navbar-toggler' margin-left='10px'><i class='fa fa-video-camera' style='font-size:25px;color:black;' aria-hidden='true'></i></label>";
        case "2": return "<label class='navbar-toggler' margin-left='10px'><i class='fa fa-youtube' style='font-size:25px;color:black;' aria-hidden='true'></i></label>";
        default: return node;
    }
}

//sets ID for deleting stream
function setDelID(node){
    document.getElementById("delID").value = node.parentElement.parentElement.cells[0].innerHTML;
}

//creates buttons in list for new entries
function createActionButtons(xml) {
    var value = '<button class="fa fa-trash-o"  type="button" style="font-size:30px; color:rgba(0, 134, 204); background:transparent; border:none "  data-toggle="modal" data-target="#ModalDelete" onclick="setDelID(this)"></button>';
    if (xml.getElementsByTagName("active")[0].childNodes[0].nodeValue == 0) {
        value = value + '<i id="testID" class="fa fa-toggle-off fa_custom_off fa-2x" style="width:25%" onclick="startStop(this)"></i>'
    }
    else {
        value = value + '<i  class="fa fa-toggle-on fa_custom_on fa-2x" style="width:25%" onclick="startStop(this)"></i>'
    }
    value = value + "";
    return value;
}

//gets resolustion options from cam
function getResolution() {
    var frame = document.getElementById("hidden-form-resolution").contentWindow.document.getElementsByTagName("pre")[0].innerHTML; // hier try catch vllt ueberall
    var index = frame.indexOf("=");
    var resolutionString = frame.substring(index + 1);
    var resolutionArray = resolutionString.split(",");
    var select = document.getElementById("resolution");


    for (i = 0; i < resolutionArray.length; i++) {
        select.options[select.options.length] = new Option(resolutionArray[i]);
    }
}

//starts and stops individual stream based on selected toggle option
function startStop(node) {
    var myid = node.parentElement.parentElement.cells[0].innerHTML;

    if (!(node.className == "fa fa-toggle-on fa_custom_on fa-2x")) {
        node.className = "fa fa-toggle-on fa_custom_on fa-2x";
        document.getElementById("startID").value = myid;
        document.getElementById("startStream").submit();
    }
    else {
        node.className = "fa fa-toggle-off fa_custom_off fa-2x";
        document.getElementById("stopID").value = myid;
        document.getElementById("stopStream").submit();
    }
}

//deletes selected stream
function deleteEntry() {
        document.getElementById("delStream").submit();
        window.location.reload()
}

//edits selected stream
function loadXMLDoc2(id) {
    var xmlhttp = new XMLHttpRequest();
    xmlhttp.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            modalCreator(this, id);
            checkStart=false;
        }
    };
    xmlhttp.open("GET", protocol +"//" + this.ip  + ":" + port + "/local/GGVideoStreamer/output.cgi?action=list", true);
    xmlhttp.send();
    loadXMLDoc();
}

//set valid date times
function dateTimeSet(node) {
    getCalendarIndex(node.parentElement);
    switch (node.name) {
        case "startDate": node.parentElement.childNodes[4].value = "";
            node.parentElement.childNodes[4].disabled = false;
            checkAllDatetimeValues(node, 0);
            break;

        case "toDate": checkDatetimeValue(node);
            checkAllDatetimeValues(node, 1);
            break;
    }
}

//checks if individual input date time is valid
function checkDatetimeValue(node) {
    if (node.value <= node.parentElement.childNodes[2].value) {
        node.value = "";
    }
}

//checks if all input date times are valid
function checkAllDatetimeValues(node, value) {
    if (value == 0) {
        for (i = 0; i < myCalendarEntries.length; i++) {
            if (node.parentElement != myCalendarEntries[i]) {
                if (node.value == myCalendarEntries[i].childNodes[2].value || node.value == myCalendarEntries[i].childNodes[4].value) {
                    node.value = "";
                    node.parentElement.childNodes[4].disabled = true;
                    node.parentElement.childNodes[4].value = "";
                }
                if (node.value > myCalendarEntries[i].childNodes[2].value && node.value < myCalendarEntries[i].childNodes[4].value) {
                    node.value = "";
                    node.parentElement.childNodes[4].disabled = true;
                    node.parentElement.childNodes[4].value = "";
                }
            }
        }
    }
    else {
        var h = true;
        for (i = 0; i < myCalendarEntries.length; i++) {
            if (node.parentElement != myCalendarEntries[i]) {
                if (node.value == myCalendarEntries[i].childNodes[2].value || node.value == myCalendarEntries[i].childNodes[4].value) {
                    node.value = "";
                    h = false;
                }
                if (node.value > myCalendarEntries[i].childNodes[2].value && node.value < myCalendarEntries[i].childNodes[4].value) {
                    node.value = "";
                    h = false;
                }
                if (node.parentElement.childNodes[2].value < myCalendarEntries[i].childNodes[2].value && node.value > myCalendarEntries[i].childNodes[4].value) {
                    node.value = "";
                    h = false;
                }
            }
        }
        if (calendarIndex + 1 < myCalendarEntries.length){
            if (h) {
                myCalendarEntries[calendarIndex + 1].childNodes[2].disabled = false;
            }
        }
    }
}

//checks time model 'weekdays' setting
function checkTimeValuesWeekdays(node) {
    if (node.id == "From") {
        document.getElementById("To").disabled = false;
        document.getElementById("To").value = "";
    }
    else {
        if (node.value <= document.getElementById("From").value) {
            node.value = "";
        }
    }
}

//gets the amount of selected calendar dates/entries
function getCalendarIndex(node) {
    for (i = 0; i < myCalendarEntries.length; i++) {
        if (node == myCalendarEntries[i]) {
            calendarIndex = i;
        }
    }
}

//checks if end times are set
function checkIfTimeSet(calendar) {
    if (myCalenderEntries.length > 0 && calendar.childNodes[myCalendarEntries.length].childNodes[4].value != "") {
        return true;
    }
    else {
        return false;
    }
}

//adds new Calendar elements/ deletes selected old entries
function addCalendarElement(node, defaultValue) {
    var calendar = document.getElementById("calendar");
    
    try {
        //if previously less entries than now selected: create new entries
        console.log("Calendar elements: " + parseInt(node.value));
        if (myCalendarEntries.length <= 1 || myCalendarEntries.length < parseInt(node.value)) {
            for (i = myCalendarEntries.length; i < parseInt(node.value); i++) {
                var entry = document.createElement('div');
                entry.className = "calendarEntries";
                if (checkIfTimeSet(calendar)) {
                    html = '<br><label>'+startValue+' </label><input type="datetime-local" name="startDate" onchange="dateTimeSet(this)"/><label>'+endValue+' </label><input type="datetime-local" name="toDate" onchange="dateTimeSet(this)" disabled/>'
                } else {
                    html = '<br><label>'+startValue+' </label><input type="datetime-local" name="startDate" onchange="dateTimeSet(this)" disabled/><label>'+endValue+'</label><input type="datetime-local" name="toDate" onchange="dateTimeSet(this)" disabled/>'
                }
                entry.innerHTML = html;
                calendar.appendChild(entry);
            }
        }

        //if previously more entries than now selected: delete old entries
        else {
            var beforeEntries = myCalendarEntries.length;
            var selectValue = parseInt(node.value);
            if(defaultValue == true){
                selectValue = 0;
            }

            for (i = beforeEntries; i > selectValue; i--) {
                calendar.removeChild(calendar.childNodes[i]);
            }
        }
    }
    catch (e) {
        //console.log(e);
        try {
            calendar.innerHTML = "";
            calendar.appendChild(node);

        }
        catch (e) { }
        var index = parseInt(node.value);
        for (i = 0; i < index; i++) {
            var entry = document.createElement('div');
            entry.className = "calendarEntries";
            if (i == 0) {
                html = '<br><label>'+startValue+' </label><input type="datetime-local" name="startDate" onchange="dateTimeSet(this)"/><label>'+endValue+' </label><input type="datetime-local" name="toDate" onchange="dateTimeSet(this)" disabled/>'
            } else {
                html = '<br><label>'+startValue+'</label><input type="datetime-local" name="startDate" onchange="dateTimeSet(this)" disabled/><label>'+endValue+' </label><input type="datetime-local" name="toDate" onchange="dateTimeSet(this)" disabled/>'
            }
            entry.innerHTML = html;
            calendar.appendChild(entry);
        }
    }
    myCalendarEntries = document.getElementsByClassName("calendarEntries");
}

//creates settings-modal for new stream
function modalCreator(xml, id) {
    var i;
    var xmlDoc = xml.responseXML;
    var x = xmlDoc.getElementsByTagName("stream");
    if (id != -1) {
        for (i = 0; i < x.length; i++) {
            try {
                if (x[i].getElementsByTagName("ID")[0].childNodes[0].nodeValue == id) {
                    checkXMLvalue(x[i]);
                }
            }
            catch (error) {
            }
        }
    }
    else {
        setModalValuesDefault();
    }
    document.getElementById("table").innerHTML = table;
};

//sets default values for setting-modal of a new stream
function setModalValuesDefault() {
    document.getElementById("format").innerHTML = 'Stream <i class="dot" id="stateOn" style="font-size:20px;background-color: gainsboro;">';
 
    document.getElementById("timeTable").selectedIndex = "0";
    changeTimeTable(document.getElementById("timeTable"));
    
    setDefaultWeekdays();
    document.getElementById("formatSelect").value = "RTMP";  
}

//resets weekdays to default
function setDefaultWeekdays() {
    document.getElementById("termine").value = 1;
    document.getElementById("Montag").checked = false;
    document.getElementById("Dienstag").checked = false;
    document.getElementById("Mittwoch").checked = false;
    document.getElementById("Donnerstag").checked = false;
    document.getElementById("Freitag").checked = false;
    document.getElementById("Samstag").checked = false;
    document.getElementById("Sonntag").checked = false;
    document.getElementById("From").value = "";
    document.getElementById("To").value = "";
    document.getElementById("To").disabled = true;
    addCalendarElement(document.getElementById("termine"),true);
    document.getElementById("audio").selectedIndex = "0";
}

//checks Min and Max Value of input answers
function checkMinMaxValue(node) {
    var max = parseInt(node.max);
    var min = parseInt(node.min);
    if (node.value > max) {
        node.value = Math.round(max / 2);
    }
    if (node.value < min) {
        node.value = Math.round(max / 2);
    }
}

//checks/sets specific values based on individual stream settings
function checkXMLvalue(x) {
    var value = "";
    var timeTable = "0"; 
    var timeSettings = ""; 
    for (opt = 0; opt < xmlOptions.length; opt++) {
        var tag = xmlOptions[opt];

        try {
            value = x.getElementsByTagName(tag)[0].childNodes[0].nodeValue;

            switch (tag) {
                case "format":
                    switch (value) {
                        case "0": 
                            document.getElementById(tag).innerHTML = 'Error <i class="dot" id="stateOn" style="font-size:20px;background-color: gainsboro;">'; 
                            document.getElementById("formatSelect").value = "RTMP"; 
                            break;
                        case "1": 
                            document.getElementById(tag).innerHTML = 'RTMP <i class="dot" id="stateOn" style="font-size:20px;background-color: gainsboro;">'; 
                            document.getElementById("formatSelect").value = "RTMP"; 
                            break;
                        case "2": 
                            document.getElementById(tag).innerHTML = 'Youtube <i class="dot" id="stateOn" style="font-size:20px;background-color: gainsboro;">'; 
                            document.getElementById("formatSelect").value = "Youtube"; 
                            break;
                        default: 
                            document.getElementById(tag).innerHTML = 'Error <i class="dot" id="stateOn" style="font-size:20px;background-color: gainsboro;">'; 
                            break;
                    }
                    break;
                case "timeTable":
                    timeTable = value;
                    break;
                case "audio":
                    switch (value) {
                        case "0": document.getElementById("myaudio").selectedIndex= value; break;
                        case "1": document.getElementById("myaudio").selectedIndex= value; break;
                        case "2": document.getElementById("myaudio").selectedIndex = value; break;
                        default: document.getElementById("myaudio").selectedIndex = "0"; break;
                    }
                    break;
                case "active":
                    switch (value) {
                        case "0": document.getElementById("stateOn").style.background = "gainsboro"; break;
                        case "1": document.getElementById("stateOn").style.background = "red"; break;
                        default: document("stateOn").style.background = "gainsboro"; break;
                    }
                    break;
                case "generalSettings":
                    setGeneralSettingsModal(value);
                    break;
                case "timeSettings": 
                    timeSettings = value;
                    break;
                default: 
                    document.getElementById(tag).value = value;
            }
        }

        catch (e) {
        }
    }
    setTimeSettings(timeTable, timeSettings);
}

//Funktion setTimeSettings setzt an Hand der Timetable die Werte der TimeSettings >> toDo: umschreiben auf timetable tag!!!
function setTimeSettings(timeTable, timeSettings) {

    switch (timeTable) {
        case "1": 
            document.getElementById("timeTable").selectedIndex = "0"; 
            console.log(document.getElementById("timeTable").value); 
            changeTimeTable(document.getElementById("timeTable")); 
            break;
        case "2": 
            document.getElementById("timeTable").selectedIndex = "1"; 
            changeTimeTable(document.getElementById("timeTable")); 
            break;
        case "3": 
            document.getElementById("timeTable").selectedIndex = "2"; 
            changeTimeTable(document.getElementById("timeTable")); 
            break;
        default: 
            document.getElementById("timeTable").selectedIndex = "1";
            changeTimeTable(document.getElementById("timeTable")); 
            break;
    }

    if (timeTable == "2") {
        setTimeSettingsWeekdays(timeSettings);
    }
    else if (timeTable == "3") {
        setTimeSettingsDate(timeSettings);
    }
}

//interprets weekdays from output.cgi and sets values for each stream
function setTimeSettingsWeekdays(value) {
    var splitter = value.split("&");
    for (i = 0; i < splitter.length; i++) {
        var keyvalue = splitter[i].split("=");
        if (keyvalue[0] == "From" || keyvalue[0] == "To") {
            var clock = keyvalue[1];
            var hour = checkTimeSize(Math.floor(clock / 60));
            var min = checkTimeSize(clock % 60);
            console.log(hour + ":" + min);
            document.getElementById(keyvalue[0]).disabled = false;
            document.getElementById(keyvalue[0]).value = hour + ":" + min;
        }
        else {
            document.getElementById(keyvalue[0]).checked = (keyvalue[1].includes("true"));
        }
    }
}

//interprets start and end times for calendar from output.cgi and sets values for each stream
function setTimeSettingsDate(value) {
    var splitter = value.split("&");
    document.getElementById("termine").value = splitter.length;
    addCalendarElement(document.getElementById("termine"),false);
    calendarEntries = document.getElementsByClassName("calendarEntries");
    var keys, startdate, enddate, endtime, starttime, hour, min;
    for (i = 0; i < splitter.length; i++) {
        keys = splitter[i].split("|");
        startdate = keys[0];
        starttime = keys[1];
        enddate = keys[2];
        endtime = keys[3];
        calendarEntries[i].childNodes[2].disabled = false;

        hour = Math.floor(starttime / 60);
        hour = checkTimeSize(hour);
        min = starttime % 60;
        min = checkTimeSize(min);
        console.log(hour + ":" + min);
        calendarEntries[i].childNodes[2].value = startdate + "T" + hour + ":" + min;

        hour = Math.floor(endtime / 60);
        hour = checkTimeSize(hour);
        min = endtime % 60;
        min = checkTimeSize(min);
        console.log(hour + ":" + min);
        calendarEntries[i].childNodes[4].disabled = false;
        calendarEntries[i].childNodes[4].value = enddate + "T" + hour + ":" + min;
    }
}

//checks if node has two digits, if not adds "0" in front
function checkTimeSize(node) {
    var h = "0" + node;
    if (h.length > 2) {
        h = h.substring(1);
    }
    return h;
}

//checks user settings from cam
function checkUserAngaben(){
    var frame = document.getElementById("hidden-form-user").contentWindow.document.getElementsByTagName("pre")[0].innerHTML;
    var index = frame.indexOf("=");
    frame = frame.substring(index+1);
    frame = frame.trim();
    console.log(frame);
    if(userset[0].childNodes[0] == undefined){
        /*hier prüfen*/
        document.getElementById("buttonUser1").click();
        document.getElementById("buttonUser").click();
    }
    else{
        if(userset[0].childNodes[0].nodeValue=="anonymous"){
            if(frame != "anonymous"){
               // alert("Bitte aktivieren Sie in Ihrer Kamera den Anonymen Betrachter!");
                document.getElementById("buttonUser2").click();
            }
            else{
                document.getElementById("usermode").selectedIndex = 0;
            }
        }
        else{
            document.getElementById("usermode").selectedIndex=1;
            setLoginMode(document.getElementById("usermode"));
            document.getElementById("setUser").value = userset[0].childNodes[0].nodeValue;
        }
    }
}

//interprets miscellaneous stream settings from output.cgi and sets values for each stream
function setGeneralSettingsModal(wert) {
    var splitter = wert.split("&");
    for (i = 0; i < splitter.length; i++) {
        var keyvalue = splitter[i].split("=");
        switch (keyvalue[0]) {
            case "resolution": document.getElementById("resolution").value = keyvalue[1]; console.log(keyvalue[1]); break;
            case "fps": document.getElementById("fps").value = keyvalue[1]; break;
            case "compression": document.getElementById("compression").value = keyvalue[1]; break;
            case "videokeyframeinterval": document.getElementById("videokeyframeinterval").value = keyvalue[1]; break;
            case "h264profile": document.getElementById("h264profile").value = keyvalue[1]; break;
            case "videobitratemode": console.log(keyvalue[1]); if (keyvalue[1] == "mbr") { document.getElementById("videobitratemode").selectedIndex = 0; document.getElementById("divVideoMaxBitrate").hidden = false; } else { document.getElementById("videobitratemode").selectedIndex = 1; document.getElementById("divVideoMaxBitrate").hidden = true; }; break;
            case "videomaxbitrate": document.getElementById("videomaxbitrate").value = keyvalue[1]; break;
            default: console.log("error");
        }
    }
}

//sets ID on Null (-1)
function setIdNull() {
    console.log("ID -1");
    id = -1;
}

//changes Video-Format Name in Modal header based on selection in dropdown
function changeFormatSelect(node) {
    document.getElementById("format").innerHTML = node.value;
}

//saves stream settings
function saveStream() {
    //for new stream
    if (id == -1) {
        addGeneralSettings("addGeneralSettings");
        addTimeTable("addTimeTable");
        addTimeSettings("addTimeSettings");
        addAudioSettings("addAudio");
        addFormatSettings("addMyFormat");
        document.getElementById("addOutput").value = document.getElementById("output").value;
        document.getElementById("addModal").submit();
    }

    //for existing stream
    else {
        addGeneralSettings("generalSettings");
        addTimeTable("tableTime");
        addTimeSettings("settingsTime");
        addAudioSettings("audio");
        addFormatSettings("myFormat");
        document.getElementById("editModal").submit();
    }

    document.getElementById("closeModalStreamSettings").click();
    window.location.reload();
}

//adds format settings based on user selection in html
function addFormatSettings(value) {
    var format = document.getElementById("formatSelect").selectedIndex;
    console.log(format);
    switch (format) {
        case 0: document.getElementById(value).value = "1"; break;
        case 1: document.getElementById(value).value = "2"; break;
        default: document.getElementById(value).value = "0";
    }
}

//adds audio settings based on user selection in html
function addAudioSettings(value) {
    var audioValue = document.getElementById("myaudio").selectedIndex;
    switch (audioValue) {
        case 0: document.getElementById(value).value = "0"; break;
        case 1: document.getElementById(value).value = "1"; break;
        case 2: document.getElementById(value).value = "2"; break;
        default: document.getElementById(value).value = "Error";
    }
}

//adds time format settings based on user selection in html
function addTimeSettings(value) {
    var timeTable = document.getElementById("timeTable").selectedIndex;
    switch (timeTable) {
        case 0: document.getElementById(value).value = ""; break;
        case 1: addWeekdaysTimeSettings(value); break;
        case 2: addCalendarTimeSettings(value); break;
        default: document.getElementById(value).value = "error";
    }
}

//adds weekday settings based on user selection in html
function addWeekdaysTimeSettings(value) {
    var timeFrom = document.getElementById("From").value;
    var timeTo = document.getElementById("To").value;
    var help = "Montag=" + document.getElementById("Montag").checked + "&Dienstag=" + document.getElementById("Dienstag").checked + "&Mittwoch=" + document.getElementById("Mittwoch").checked + "&Donnerstag=" + document.getElementById("Donnerstag").checked + "&Freitag=" + document.getElementById("Freitag").checked + "&Samstag=" + document.getElementById("Samstag").checked + "&Sonntag=" + document.getElementById("Sonntag").checked + "&";
    help = help + "From=" + calculateTime(timeFrom) + "&To=" + calculateTime(timeTo);
    document.getElementById(value).value = help;
}

//adds calendar settings based on user selection in html
function addCalendarTimeSettings(value) {
    var help, startDate, endDate, timeFrom, timeTo;
    help = "";
    var splitter;
    var calendarEntries = document.getElementsByClassName("calendarEntries");
    for (i = 0; i < calendarEntries.length; i++) {
        if (i != 0) {
            help = help + "&";
        }
        splitter = calendarEntries[i].childNodes[2].value.split("T");
        startDate = splitter[0];
        timeFrom = splitter[1];
        splitter = calendarEntries[i].childNodes[4].value.split("T");
        endDate = splitter[0];
        timeTo = splitter[1];
        help = help + startDate + "|" + calculateTime(timeFrom) + "|" + endDate + "|" + calculateTime(timeTo);
    }
    document.getElementById(value).value = help;
    console.log(help);
}

//calculates/formats time settings
function calculateTime(time) {
    var calcTime;
    console.log(time);
    var splitter = time.split(":");
    calcTime = splitter[0] * 60 + splitter[1] * 1;
    return calcTime;
}

//adds time talbe based on user selection in html
function addTimeTable(value) {
    var timetable = document.getElementById("timeTable").selectedIndex;
    switch (timetable) {
        case 0: document.getElementById(value).value = "1"; break;
        case 1: document.getElementById(value).value = "2"; break;
        case 2: document.getElementById(value).value = "3"; break;
        default: document.getElementById(value).value = "0";
    }
}

//adds miscellaneous settings based on user selection in html
function addGeneralSettings(value) {
    var help = "";
    if (document.getElementById("videobitratemode").selectedIndex == 1) {
        help = "resolution=" + document.getElementById("resolution").value + "&fps=" + document.getElementById("fps").value + "&compression=" + document.getElementById("compression").value + "&videokeyframeinterval=" + document.getElementById("videokeyframeinterval").value + "&h264profile=" + document.getElementById("h264profile").value + "&videobitratemode=vbr&videocodec=h264";
    }
    else {
        help = "resolution=" + document.getElementById("resolution").value + "&fps=" + document.getElementById("fps").value + "&compression=" + document.getElementById("compression").value + "&videokeyframeinterval=" + document.getElementById("videokeyframeinterval").value + "&h264profile=" + document.getElementById("h264profile").value + "&videomaxbitrate=" + document.getElementById("videomaxbitrate").value + "&videobitratemode=mbr&videocodec=h264";
    }
    document.getElementById(value).value = help;
}

//sets ID for streams
function setID(node) {
    id = node.cells[0].innerHTML;
}

//opens G&G homepage in new tab
function goToGG() {
    window.open('http://www.gg-sicherheit.de');
}

//checks if max bitrate is selected and hides/shows related input field
function checkVideoBitrateMode(node) {
    if (node.selectedIndex == 1) {
        document.getElementById("divVideoMaxBitrate").hidden = true;
    }
    else {
        document.getElementById("divVideoMaxBitrate").hidden = false;
    }
}

//opens G&G YouTube in new tab
function goToYoutube() {
    window.open('https://www.youtube.com/channel/UCAPfMadiR5Gse5LKZ3A07uw');
}

//opens G&G Instagram in new tab
function goToInsta() {
    window.open('https://www.instagram.com/gundgsicherheitstechnikgmbh/');
}

//opens G&G Facebook in new tab
function goToFacebook() {
    window.open('https://www.facebook.com/Gefahrenmeldeanlagen');
}

//hides/shows related input fields based on selected user mode
function setLoginMode(node) {
    if (node.selectedIndex == 0) {
        document.getElementById("setUserData").hidden = true;
    }
    else {
        document.getElementById("setUserData").hidden = false;
    }
}

//gets users created in cam settings
function getUsers() {
    if (users) {
        var frame = document.getElementById("myhiddenform").contentWindow.document.getElementsByTagName("pre")[0].innerHTML;
        var index = frame.indexOf("diguser");
        frame = frame.substring(index);
        index = frame.indexOf("\"");
        frame = frame.substring(index + 1);
        index = frame.indexOf("\"");
        frame.substring(0, index);
        frame = frame.substring(0, frame.length - 2);
        console.log(frame);

        var splitter = frame.split(",");

        var select = document.getElementById("setUser");
        
        for (i = 0; i < splitter.length; i++) {
            select.options[select.options.length] = new Option(splitter[i]);
            console.log(splitter[i]);
        }
    }
    users = false;
}

//deletes input password values
function deletePasswordEntry(){
    document.getElementById("pass").value = "";
}

//sends input user data to cam
function sendUserData() {
    var select = document.getElementById("usermode");
    if (select.selectedIndex == 0) {
        document.getElementById("sendAnom").submit();
        document.getElementById("closeModalUserSettings").click();
    }
    else {
        var username = document.getElementById("setUser").value;
        var password = document.getElementById("pass").value;
        document.getElementById("password").value = password;
        document.getElementById("username").value = username;
        if (password != "") {
            var xml = new XMLHttpRequest();
            xml.onreadystatechange = function () {
                if (this.readyState == 4){
                    if(this.status == 200) {
                        document.getElementById("sendUser").submit();
                        document.getElementById("closeModalUserSettings").click();
                    }else{
                        document.getElementById("buttonUserPassword").click();
                    }
                }
            }; 

        xml.open("GET", protocol +"//"+ip+":"+port+"/axis-cgi/imagesize.cgi?camera=1", true, username ,password);
        xml.send();
        }
        else {
            document.getElementById("buttonUserPassword").click();
        }
    }
    document.getElementById("pass").value="";
}

//checks selected language
function checkLanguageValue (node){
    switch (node){
        case "Deutsch": return 0;
        case "Englisch": return 1;
        case "Franzoesisch": return 2;
        case "Japanisch": return 3;
    }
}

//loads app in selected language
function loadLanguage(node) {
    var xmlhttp = new XMLHttpRequest();
    value = node.id;
    value = value.substring(1);
    currentLanguage = value;
    document.getElementById("setLanguage").value = checkLanguageValue(currentLanguage);
    document.getElementById("languageForm").submit();
    xmlhttp.onreadystatechange = function () {
        if (this.readyState == 4 && this.status == 200) {
            setLanguage(this,value)
        }
    };
    xmlhttp.open("GET", "language.xml", true);

    xmlhttp.send();
}

//defines text values based on selected language
function setLanguage(xml,value) {
    var xmlDoc = xml.responseXML;
    var x = xmlDoc.getElementsByTagName(value);
        tagArrayList = x[0].childNodes;
        for (i = 0; i < tagArrayList.length; i++) {
            try {
               if(tagArrayList[i]!="text"){
                    myvalue=  x[0].getElementsByTagName(tagArrayList[i].nodeName)[0].childNodes[0].nodeValue;
                    if(tagArrayList[i].nodeName=="lStart" || tagArrayList[i].nodeName=="lEnde" ){
                        if (tagArrayList[i].nodeName=="lStart"){
                            startValue = myvalue;
                        }
                        else{
                            endValue=myvalue;
                        }
                    }
                    else{
                        document.getElementById(tagArrayList[i].nodeName).innerHTML = myvalue;
                    }  
               }
            }
            catch (error) {

            }
        }
}

